<?php

namespace Lc\PietroBundle\Container\Dream;

use Lc\PietroBundle\Factory\Dream\DreamFactory;
use Lc\PietroBundle\Repository\Dream\DreamRepositoryQuery;
use Lc\PietroBundle\Repository\Dream\DreamStore;

class DreamContainer
{
    protected DreamFactory $factory;
    protected DreamRepositoryQuery $repositoryQuery;
    protected DreamStore $store;

    public function __construct(
            DreamFactory $factory,
            DreamRepositoryQuery $repositoryQuery,
            DreamStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): DreamFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): DreamRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): DreamStore
    {
        return $this->store;
    }
}
