<?php

namespace Lc\PietroBundle\Container\Territory;

use Lc\PietroBundle\Factory\Territory\TerritoryFactory;
use Lc\PietroBundle\Repository\Territory\TerritoryRepositoryQuery;
use Lc\PietroBundle\Repository\Territory\TerritoryStore;

class TerritoryContainer
{
    protected TerritoryFactory $factory;
    protected TerritoryRepositoryQuery $repositoryQuery;
    protected TerritoryStore $store;

    public function __construct(
            TerritoryFactory $factory,
            TerritoryRepositoryQuery $repositoryQuery,
            TerritoryStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): TerritoryFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): TerritoryRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): TerritoryStore
    {
        return $this->store;
    }
}
