<?php

namespace Lc\PietroBundle\Container\Workshop;

use Lc\PietroBundle\Definition\Field\Workshop\SolutionFieldDefinition;
use Lc\PietroBundle\Factory\Workshop\SolutionFactory;
use Lc\PietroBundle\Repository\Workshop\SolutionRepositoryQuery;
use Lc\PietroBundle\Repository\Workshop\SolutionStore;

class SolutionContainer
{
    protected SolutionFactory $factory;
    protected SolutionRepositoryQuery $repositoryQuery;
    protected SolutionStore $store;
    protected SolutionFieldDefinition $fieldDefinition;

    public function __construct(
            SolutionFactory $factory,
            SolutionRepositoryQuery $repositoryQuery,
            SolutionStore $store,
            SolutionFieldDefinition $fieldDefinition
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->fieldDefinition = $fieldDefinition;
    }

    public function getFactory(): SolutionFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): SolutionRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): SolutionStore
    {
        return $this->store;
    }

    public function getFieldDefinition(): SolutionFieldDefinition
    {
        return $this->fieldDefinition;
    }
}
