<?php

namespace Lc\PietroBundle\Container\Workshop;

use Lc\PietroBundle\Definition\Field\Workshop\WorkshopFieldDefinition;
use Lc\PietroBundle\Factory\Workshop\WorkshopFactory;
use Lc\PietroBundle\Repository\Workshop\WorkshopRepositoryQuery;
use Lc\PietroBundle\Repository\Workshop\WorkshopStore;
use Lc\PietroBundle\Solver\Workshop\WorkshopSolver;

class WorkshopContainer
{
    protected WorkshopFactory $factory;
    protected WorkshopRepositoryQuery $repositoryQuery;
    protected WorkshopStore $store;
    protected WorkshopFieldDefinition $fieldDefinition;
    protected WorkshopSolver $solver;

    public function __construct(
            WorkshopFactory $factory,
            WorkshopRepositoryQuery $repositoryQuery,
            WorkshopStore $store,
            WorkshopFieldDefinition $fieldDefinition,
            WorkshopSolver $solver
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->fieldDefinition = $fieldDefinition;
        $this->solver = $solver;
    }

    public function getFactory(): WorkshopFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): WorkshopRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): WorkshopStore
    {
        return $this->store;
    }

    public function getFieldDefinition(): WorkshopFieldDefinition
    {
        return $this->fieldDefinition;
    }

    public function getSolver(): WorkshopSolver
    {
        return $this->solver;
    }
}
