<?php

namespace Lc\PietroBundle\Container\Workshop;

use Lc\PietroBundle\Definition\Field\Workshop\WorkshopThematicFieldDefinition;
use Lc\PietroBundle\Factory\Workshop\WorkshopThematicFactory;
use Lc\PietroBundle\Repository\Workshop\WorkshopThematicRepositoryQuery;
use Lc\PietroBundle\Repository\Workshop\WorkshopThematicStore;

class WorkshopThematicContainer
{
    protected WorkshopThematicFactory $factory;
    protected WorkshopThematicRepositoryQuery $repositoryQuery;
    protected WorkshopThematicStore $store;
    protected WorkshopThematicFieldDefinition $fieldDefinition;

    public function __construct(
            WorkshopThematicFactory $factory,
            WorkshopThematicRepositoryQuery $repositoryQuery,
            WorkshopThematicStore $store,
            WorkshopThematicFieldDefinition $fieldDefinition
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->fieldDefinition = $fieldDefinition;
    }

    public function getFactory(): WorkshopThematicFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): WorkshopThematicRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): WorkshopThematicStore
    {
        return $this->store;
    }

    public function getFieldDefinition(): WorkshopThematicFieldDefinition
    {
        return $this->fieldDefinition;
    }
}
