<?php

namespace Lc\PietroBundle\Definition\Field\Workshop;

use EasyCorp\Bundle\EasyAdminBundle\Field\AssociationField;
use EasyCorp\Bundle\EasyAdminBundle\Field\TextareaField;
use EasyCorp\Bundle\EasyAdminBundle\Field\TextField;
use Lc\SovBundle\Definition\Field\AbstractFieldDefinition;
use Lc\SovBundle\Field\CKEditorField;
use Lc\SovBundle\Field\ImageManagerField;

class WorkshopThematicFieldDefinition extends AbstractFieldDefinition
{
    public function configureIndex(): array
    {
        return [
            'image',
            'title',
        ];
    }

    public function configureForm(): array
    {
        return [
                'image',
                'title',
                'description',
                'color',
                'devAlias',
        ];
    }

    public function configureFields(): array
    {
        return [
            'image' => ImageManagerField::new('image'),
            'title' => TextField::new('title'),
            'description' => TextareaField::new('description'),
            'color' => TextField::new('color'),
        ];
    }
}