<?php

namespace Lc\PietroBundle\Model\Workshop;

use Doctrine\ORM\Mapping as ORM;
use Lc\SovBundle\Doctrine\EntityInterface;
use Lc\SovBundle\Doctrine\Pattern\AbstractFullEntity;

/**
 * @ORM\MappedSuperclass()
 */
abstract class Solution extends AbstractFullEntity implements SolutionInterface, EntityInterface
{
    /**
     * @ORM\ManyToOne(targetEntity="Lc\PietroBundle\Model\Workshop\WorkshopInterface", inversedBy="solutions")
     */
    protected $workshop;

    /**
     * @ORM\Column(type="string", length=256, nullable=true)
     */
    protected $videoLink;

    public function getWorkshop(): ?WorkshopInterface
    {
        return $this->workshop;
    }

    public function setWorkshop(WorkshopInterface $workshop): self
    {
        $this->workshop = $workshop;

        return $this;
    }

    public function getVideoLink(): ?string
    {
        return $this->videoLink;
    }

    public function setVideoLink(?string $videoLink): self
    {
        $this->videoLink = $videoLink;

        return $this;
    }
}
